﻿Imports Windows.Foundation

Namespace ParseJSON.Utility
    Public NotInheritable Class ContactsController
        'Region "AddPerson Async Support"
        Public Function AddContactAsync(ByVal personJson As String) As IAsyncOperation(Of String)
            Return Task.Run(Of String)(Async Function() Await StartAddContactTask(personJson)).AsAsyncOperation()
        End Function

        Private Function StartAddContactTask(ByVal personJson As String) As Task(Of String)
            Return Task.Factory.StartNew(Of String)(Function() Me.AddContact(personJson))
        End Function
        'End Region

        Private Function AddContact(ByVal personJson As String) As String
            Dim person As Person = PersonFactory.Create(personJson)

            Return String.Format("{0} {1} is added to the system.", person.FirstName, person.LastName)
        End Function

        'Region "AddPerson Async Support"
        Public Function AddContactsAsync(ByVal personJson As String) As IAsyncOperation(Of String)
            Return Task.Run(Of String)(Async Function() Await StartAddContactsTask(personJson)).AsAsyncOperation()
        End Function

        Private Function StartAddContactsTask(ByVal personJson As String) As Task(Of String)
            Return Task.Factory.StartNew(Of String)(Function() Me.AddContacts(personJson))
        End Function
        'End Region

        Private Function AddContacts(ByVal personJson As String) As String
            Dim people As IList(Of Person) = PersonFactory.CreateList(personJson)

            Return String.Format("{0} {1} and {2} {3} are added to the system.", people(0).FirstName, people(0).LastName, people(1).FirstName, people(1).LastName)
        End Function

    End Class
End Namespace
