﻿Imports System
Imports System.Collections.Generic
Imports Windows.Data.Json

Namespace ParseJSON.Utility
    Friend Class PersonFactory
        Public Shared Function Create(ByVal jsonString As String) As Person
            Dim json As JsonValue
            Dim person As New Person()

            If JsonValue.TryParse(jsonString, json) Then
                person = PersonFactory.Create(json)
            End If

            Return person
        End Function

        Public Shared Function Create(ByVal personValue As JsonValue) As Person
            Dim person As New Person()

            Dim jsonObject As JsonObject = personValue.GetObject()

            Dim id? As Integer = jsonObject.GetIntegerValue("id")
            If id.HasValue Then
                person.Id = id.Value
            End If

            person.FirstName = jsonObject.GetStringValue("firstName")
            person.LastName = jsonObject.GetStringValue("lastName")

            Dim isOnWestCoast? As Boolean = jsonObject.GetBooleanValue("isOnWestCoast")
            If isOnWestCoast.HasValue Then
                person.IsOnWestCoast = isOnWestCoast.Value
            End If

            Return person
        End Function

        Public Shared Function CreateList(ByVal peopleJson As String) As IList(Of Person)
            Dim people As New List(Of Person)()
            Dim array As New JsonArray()

            If JsonArray.TryParse(peopleJson, array) Then
                If array.Count > 0 Then
                    For Each value As JsonValue In array
                        people.Add(PersonFactory.Create(value))
                    Next value
                End If
            End If

            Return people
        End Function
    End Class
End Namespace
'
'
'"{
'    '_backingData': {
'        'firstName': 'Craig'
'    },
'    'firstName': 'Craig',
'    'backingData': {
'        'firstName':'Craig'}
'}"
'
'